<?php

require_once 'custom/PxRoutines/LogicBuilderPackages/lb60744dd943b426_37706478/ControlFlow_lb60744dd943b426_37706478.php';

class FlowchartLogicHook_lb60744dd943b426_37706478{

    protected static $fetched_row;
    protected static $inProcess;
    protected static $processedCounter = 0;
    CONST MAX_FLOW_RUN = 10;

    public function firstBeforeSave(SugarBean $bean, $event, $args){
        if(empty($args['isUpdate']))
            self::$processedCounter++;

        if($this->isRecordNew($bean))
            $this->initNewRecord($bean);
    }

    public function rememberFetchedRow(SugarBean $bean, $event, $args){
        if(empty($bean->id)){
            self::$fetched_row[$bean->module_name] = $bean->fetched_row;
        }else{
            self::$fetched_row[$bean->module_name][$bean->id] = $bean->fetched_row;
        }
    }

    public function firstAfterSave(SugarBean $bean, $event, $args){
        if($bean->new_with_id)
            $bean->pxIsSaved;
    }

    public function after_save(SugarBean $bean, $event, $args){
        if(empty(self::$inProcess[$bean->id]) /*&& !(empty($args['isUpdate']) && self::$processedCounter >= self::MAX_FLOW_RUN)*/){
            self::$inProcess[$bean->id] = 1;
            $processId = 'lb60744dd943b426_37706478' . $bean->id;
            $flow = new ControlFlow_lb60744dd943b426_37706478($processId);
            $flow->process(array(
                    'bean' => $bean,
                    'beanPrev' => $this->getPreviousValues($bean),
                    'isNew' => empty($args['isUpdate']),
                    'changedFields' => array_keys($args['dataChanges'])
                ));
            $flow->clearStack();
            unset(self::$inProcess[$bean->id]);
        }
    }

    protected function getPreviousValues($bean){
        $fetched_row = self::$fetched_row[$bean->module_name][$bean->id];
        return json_decode (json_encode ($fetched_row), FALSE);
    }

    protected function isRecordNew($bean){
        return empty($bean->id) || (!empty($bean->id) && !empty($bean->new_with_id));
    }
    protected function initNewRecord($bean){
        if(empty($bean->id)){
            $bean->id = Sugarcrm\Sugarcrm\Util\Uuid::uuid1();
            $bean->new_with_id = true;
        }
    }

}
