<?php

require_once 'custom/PxRoutines/LogicBuilderPackages/lb60744dd943b426_37706478/operators/FlowchartOperator_lb60744dd943b426_37706478.php';

class FindOrCreateEntityOperator_lb60744dd943b426_37706478 extends FlowchartOperator_lb60744dd943b426_37706478{

    protected $entityName;
    protected $conditions;
    protected $newEntity = null;
    protected $isNewRecord = false;

    protected $detectedEntityId = null;
    protected $detectedEntity = null;

    public function __construct($params)
    {
        parent::__construct($params);
    }

    public function setInDataPorts($params)
    {
        $this->entityName = $params['inDataPorts']['module']['value'];
        foreach ($params['inDataPorts'] as $portId => $inData) {
            $this->inDataPorts[$portId] = $inData;
            if ($portId != 'module') {
                $this->conditions[$inData['value']] = null;
            }
        }
    }

    public function setInDataPortById($id, $value)
    {
        if ($id == 'module') {
            $this->entityName = $value;
        } else {
            $fieldName = $this->inDataPorts[$id]['value'];
            $this->conditions[$fieldName] = $value;
        }
    }

    public function process($params = array())
    {
        if (empty($this->entityName)) {
            return;
        }
        $bean = BeanFactory::getBean($this->entityName);
        if (empty($bean)) {
            return;
        }
        try{
            $this->runQuery($bean);
        } catch(Exception $e) {

        }
    }

    /**
    * @param $bean
    * @throws SugarQueryException
    */
    protected function runQuery(SugarBean $bean)
    {
        $query = new SugarQuery();
        $query
            ->from($bean, array('team_security' => false))
            ->select(array('id'));
        $processSearch = true;
        foreach ($this->conditions as $fieldName => $searchValue) {
            if (!empty($bean->field_defs[$fieldName])) {
                if ($bean->field_defs[$fieldName]['source'] != 'non-db'){
                    if (empty($searchValue)) {
                        $query->where()->isEmpty($fieldName);
                    } else {
                        $query->where()->equals($fieldName, $searchValue);
                    }
                } elseif (!empty($bean->field_defs[$fieldName]['link'])) {
                    if ($bean->field_defs[$fieldName]['type'] == 'email') {
                        if (filter_var($searchValue, FILTER_VALIDATE_EMAIL)) {
                            $searchValue = strtoupper($searchValue);
                            $sql = "
                            SELECT {$bean->getTableName()}.id id
                            FROM {$bean->getTableName()}
                            INNER JOIN email_addr_bean_rel jt1_email_addr_bean_rel ON (
                                {$bean->getTableName()}.id = jt1_email_addr_bean_rel.bean_id
                                AND jt1_email_addr_bean_rel.deleted = 0
                                AND jt1_email_addr_bean_rel.bean_module = '{$bean->getModuleName()}'
                            )
                            INNER JOIN email_addresses jt0_email_addresses ON (
                                jt0_email_addresses.id = jt1_email_addr_bean_rel.email_address_id
                                AND jt0_email_addresses.deleted = 0
                            )
                            WHERE {$bean->getTableName()}.deleted = 0
                                AND jt0_email_addresses.email_address_caps = '$searchValue'
                            ";
                            $query->where()->addRaw(' ' . $bean->getTableName() . '.id in (' . $sql . ') ');
                        } else {
                            $processSearch = false;
                        }
                    } else {
                        $searchLink = $bean->field_defs[$fieldName]['link'];
                        $searchJoin = $query->join($searchLink, array('joinType' => 'INNER'));
                        $searchRelateField = $bean->field_defs[$fieldName]['rname'];
                        if (empty($searchValue)) {
                            $query->where()->isEmpty($searchJoin->joinName() . '.' . $searchRelateField);
                        } else {
                            $query->where()->equals($searchJoin->joinName() . '.' . $searchRelateField, $searchValue);
                        }
                    }
                } else {
                    $processSearch = false;
                }
            } else {
                $processSearch = false;
            }
        }
        if ($processSearch) {
            $records = $query->execute();
            if (!empty($records)) {
                $this->detectedEntityId = $records[0]['id'];
                $this->detectedEntity = BeanFactory::getBean($this->entityName, $this->detectedEntityId, ['strict_retrieve' => true]);
            }
        }
        if (!empty($this->detectedEntityId)) {
            $this->isNewRecord = false;
        } else {
            $this->isNewRecord = true;
            $this->newEntity = $bean;
        }
    }

    public function getOutDataByPortId($portId)
    {
        if ($portId == 'entity') {
            return $this->getEntity();
        } else if ($portId == 'isNewRecord') {
            return $this->isNewRecord;
        }
        return null;
    }

    protected function getEntity()
    {
        if (empty($this->isNewRecord)) {
            return $this->detectedEntity;
        } else {
            return $this->newEntity;
        }
    }
}
